/* Sistemas Integrados TECNISA
   Servios

Nome: 2868_PEDFUNO_PEDPRECO_PROD.SQL

Descrio:
   Traz o custo da composio do produto verificando se o sistema esta
   trabalhando com tabela de preos ou fator de converso.

Criao:
12/12/07 - Welbert G. Moitinha */

CREATE OR REPLACE FUNCTION PEDPRECO_PROD ( P_CDPRODUTO     IN PRODUTO.CDPRODUTO%TYPE,
                                           P_CDFILIAL IN FILIAL.CDFILIAL%TYPE,
                                           P_CDPRECOBASE IN ITEMPREBASE.CDPRECOBASE%TYPE,
                                           P_CDFATPRECO IN PRODFATOR.CDFATPRECO%TYPE)RETURN FLOAT

AS
   V_IDTABPRECO  PARAMPEDIDO.IDTABPRECO%TYPE;
   V_VRPRECOPROD FLOAT;
   V_IDCUSEXP   PAREXPEDICAO.IDCUSEXP%TYPE;
BEGIN
   V_VRPRECOPROD := 0;

   BEGIN
      SELECT P.IDTABPRECO, E.IDCUSEXP
      INTO V_IDTABPRECO, V_IDCUSEXP
      FROM PARAMPEDIDO P, PAREXPEDICAO E
      WHERE
         P.CDFILIAL = P_CDFILIAL
         AND E.CDFILIAL = P_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDTABPRECO := '';
         V_IDCUSEXP   := '';
   END;

   IF NOT V_IDTABPRECO IS NULL  THEN
      IF V_IDTABPRECO = '1' THEN
         SELECT
            VRITEPREBASE
         INTO V_VRPRECOPROD
         FROM ITEMPREBASE
         WHERE
             CDPRECOBASE = P_CDPRECOBASE
             AND CDPRODUTO = P_CDPRODUTO
             AND DTINIVALIPB <= SYSDATE
             AND NVL(DTFIMVALIPB, SYSDATE + 1000) > SYSDATE;
      ELSE
/*Custo no Estoque ou preo de cotao */
         SELECT
            DECODE(
             NVL((CUSTO_PRODUTO_LCEST( P_CDFILIAL, P_CDPRODUTO, V_IDCUSEXP,
                                        SYSDATE, SYSDATE,  BUSCA_ALMOX( P_CDFILIAL, '', P_CDPRODUTO),
                               BUSCA_LOCAL( P_CDFILIAL, '', P_CDPRODUTO)) * PR.VRFATOCONV) * F.VRFATPRECO,0), 0,

             NVL((CUSTO_PRODUTO_LCEST( P_CDFILIAL, P_CDPRODUTO, 6,
                                        SYSDATE, SYSDATE,  BUSCA_ALMOX( P_CDFILIAL, '', P_CDPRODUTO),
                                   BUSCA_LOCAL( P_CDFILIAL, '', P_CDPRODUTO)) * PR.VRFATOCONV) * F.VRFATPRECO, 0),
             NVL((CUSTO_PRODUTO_LCEST( P_CDFILIAL, P_CDPRODUTO, V_IDCUSEXP,
                                        SYSDATE, SYSDATE,  BUSCA_ALMOX( P_CDFILIAL, '', P_CDPRODUTO),
                               BUSCA_LOCAL( P_CDFILIAL, '', P_CDPRODUTO)) * PR.VRFATOCONV) * F.VRFATPRECO ,0))
         INTO
            V_VRPRECOPROD
         FROM
            PRODFATOR F, PRODUTO PR
         WHERE
            F.CDFATPRECO    = P_CDFATPRECO
            AND PR.CDPRODUTO = P_CDPRODUTO
            AND F.CDPRODUTO = PR.CDPRODUTO;
      END IF;
   END IF;
   RETURN V_VRPRECOPROD;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PEDPRECO_PROD','5.05.004'); END;
/

