/* Esta funo realiza o clculo do cumprimento do prazo do projeto para cada dia de monitoramento
@C:\Web_411\Sql\End_Conv\Oracle\9110_GEPFUNO_HORAS_CUMPRIPRAZO.SQL
*/
CREATE OR REPLACE FUNCTION HORAS_CUMPRIPRAZO
   (P_CDFILIAL   IN ITEMPRODUTO.CDFILIAL%TYPE,
    P_CDPROJETO  IN SOLISERV.NRSOLISERV%TYPE,
    P_DATAFIM    IN NOTAFISCAL.DTENTRSAID%TYPE) RETURN NUMBER
AS
   V_TOTAPLAN    PLANATIVTARE.QTTEMPLAITAR%TYPE;
   V_TEMPOREAL   PLANATIVTARE.QTTEMPLAITAR%TYPE;
   V_PERCESFORCO PLANATIVTARE.QTTEMPLAITAR%TYPE;

   V_TOTAATRA    ITEMPROIMPOS.VRBASECALCIT%TYPE;
   V_DATAFIM     NOTAFISCAL.DTENTRSAID%TYPE;
   V_DATAINI     NOTAFISCAL.DTENTRSAID%TYPE;
   V_NCONC       ITEMPROIMPOS.VRBASECALCIT%TYPE;
   V_DTMAXATIV   NOTAFISCAL.DTENTRSAID%TYPE;
   V_QTDEATIV    ITEMPROIMPOS.VRBASECALCIT%TYPE;
   V_TEMPOPLA    ITEMPROIMPOS.VRBASECALCIT%TYPE;
BEGIN
   IF P_DATAFIM IS NULL THEN
      V_DATAFIM := SYSDATE;
   ELSE
      V_DATAFIM := P_DATAFIM;
   END IF;

   V_TOTAATRA := 0;

   SELECT COUNT(*)
   INTO V_TOTAPLAN
   FROM SOLIBASELINE S, TAREFA T, PLANATIVTARE P
   WHERE S.CDFILIAL   = P_CDFILIAL   AND
         S.CDPROJETO  = P_CDPROJETO  AND
         S.CDFILIAL   = T.CDFILIAL   AND
         S.NRSOLISERV = T.NRSOLISERV AND
         T.CDFILIAL   = P.CDFILIAL   AND
         T.NRTAREFA   = P.NRTAREFA   AND
         TRUNC(DTFIPATIVTAR) < V_DATAFIM;

   SELECT SUM(P.QTTEMPLAITAR)
   INTO V_TEMPOPLA
   FROM SOLIBASELINE S, TAREFA T, PLANATIVTARE P
   WHERE S.CDFILIAL   = P_CDFILIAL   AND
         S.CDPROJETO  = P_CDPROJETO  AND
         S.CDFILIAL   = T.CDFILIAL   AND
         S.NRSOLISERV = T.NRSOLISERV AND
         T.CDFILIAL   = P.CDFILIAL   AND
         T.NRTAREFA   = P.NRTAREFA;

   SELECT ROUND(SUM(DTHFAPATIVTA - DTHIAPATIVTA)*24,2)
   INTO V_TEMPOREAL
   FROM SOLIBASELINE S, TAREFA T, APROATIVTARE A
   WHERE S.CDFILIAL   = P_CDFILIAL   AND
         S.CDPROJETO  = P_CDPROJETO  AND
         S.CDFILIAL   = T.CDFILIAL   AND
         S.NRSOLISERV = T.NRSOLISERV AND
         T.CDFILIAL   = A.CDFILIAL   AND
         T.NRTAREFA   = A.NRTAREFA;

   FOR C_SOLISERV IN (SELECT SL.CDFILIAL, SL.CDPROJETO, SL.NRSOLISERV, NVL(SO.DTCOMPROMISS, PJ.DTFIMPLANPRJ) AS DTMARCOPRJ
                      FROM SOLISERV SO, SOLIBASELINE SL, PROJETO PJ
                      WHERE SO.CDFILIAL     = SL.CDFILIAL
                        AND SO.NRSOLISERV   = SL.NRSOLISERV
                        AND SL.CDFILIAL     = PJ.CDFILIAL
                        AND SL.CDPROJETO    = PJ.CDPROJETO
                        AND SL.CDFILIAL     = P_CDFILIAL
                        AND SL.CDPROJETO    = P_CDPROJETO) LOOP

      SELECT COUNT(*)
      INTO V_NCONC
      FROM TAREFA TA, PLANATIVTARE PL
      WHERE TA.CDFILIAL   = PL.CDFILIAL
        AND TA.NRTAREFA   = PL.NRTAREFA
        AND TA.CDFILIAL   = C_SOLISERV.CDFILIAL
        AND TA.NRSOLISERV = C_SOLISERV.NRSOLISERV
        AND PL.IDSITATIVTAR <> 'C'
        AND PL.DTFIPATIVTAR IS NOT NULL;

      IF V_NCONC = 0 THEN
         BEGIN
            SELECT MAX(PL.DTCONATIVTAR)
            INTO V_DTMAXATIV
            FROM TAREFA TA, PLANATIVTARE PL
            WHERE TA.CDFILIAL = PL.CDFILIAL
              AND TA.NRTAREFA = PL.NRTAREFA
              AND TA.CDFILIAL = C_SOLISERV.CDFILIAL
              AND TA.NRSOLISERV = C_SOLISERV.NRSOLISERV
              AND PL.DTFIPATIVTAR IS NOT NULL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               NULL;
         END;

         IF V_DTMAXATIV > C_SOLISERV.DTMARCOPRJ THEN
            SELECT COUNT(*)
            INTO V_QTDEATIV
            FROM TAREFA TA, PLANATIVTARE PL
            WHERE TA.CDFILIAL = PL.CDFILIAL
              AND TA.NRTAREFA = PL.NRTAREFA
              AND TA.CDFILIAL = C_SOLISERV.CDFILIAL
              AND TA.NRSOLISERV = C_SOLISERV.NRSOLISERV
              AND PL.DTFIPATIVTAR IS NOT NULL;

            V_TOTAATRA := V_TOTAATRA + V_QTDEATIV;

         END IF;
      ELSE
         SELECT COUNT(*)
         INTO V_QTDEATIV
         FROM SOLIBASELINE S, TAREFA T, PLANATIVTARE P
         WHERE S.CDFILIAL   = C_SOLISERV.CDFILIAL
           AND S.CDPROJETO  = C_SOLISERV.CDPROJETO
           AND S.NRSOLISERV = C_SOLISERV.NRSOLISERV
           AND S.CDFILIAL   = T.CDFILIAL
           AND S.NRSOLISERV = T.NRSOLISERV
           AND T.CDFILIAL   = P.CDFILIAL
           AND T.NRTAREFA   = P.NRTAREFA
           AND TRUNC(DTFIPATIVTAR) < V_DATAFIM
           AND ((P.IDSITATIVTAR = 'C' AND TRUNC(NVL(DTFIRATIVTAR,DTCONATIVTAR)) > V_DATAFIM)
            OR  (IDSITATIVTAR <> 'C' AND TRUNC(DTFIRATIVTAR) > V_DATAFIM)
            OR  (IDSITATIVTAR <> 'C' AND DTFIRATIVTAR IS NULL));

         V_TOTAATRA := V_TOTAATRA + V_QTDEATIV;

      END IF;
   END LOOP;

   V_PERCESFORCO := 0;
   IF V_TEMPOPLA <> 0 THEN
      V_PERCESFORCO := (V_TEMPOREAL / V_TEMPOPLA);
      IF V_PERCESFORCO > 1 THEN
         V_PERCESFORCO := 1;
      END IF;
   END IF;

   IF V_TOTAPLAN = 0 THEN
      RETURN(0);
   ELSE
      IF ROUND(((V_TOTAATRA/V_TOTAPLAN) * 100) * V_PERCESFORCO,0) > 100 THEN
         RETURN(100);
      ELSE
         RETURN(ROUND(((V_TOTAATRA/V_TOTAPLAN) * 100) * V_PERCESFORCO,0));
      END IF;
   END IF;
END;
/